#!/bin/sh
# Modify by HSIAO-YANG CHEN
# crontab: * * * * *  /bin/sh /usr/kickass.sh
#

#ǿź -60
STRONG=-60
#ź -78
WEAK=-78


# ָ־ļ5GƵ豸MACַ
logfile="/tmp/kickass.log"
dev5gmacfile="/usr/devmac_5g.db" ;


#ĬԶӼƻ  
crontabsfile="/etc/crontabs/root"
if [ -z $( grep -i $0 "$crontabsfile" )  ] ; then
	echo "* * * * *  /bin/sh /usr/kickass.sh" >>$crontabsfile
	echo "00 5 * * 3 sleep 5 && touch /etc/banner && reboot" >>$crontabsfile
	echo "Add task scheduler to crontabs"
fi
#ֻһkickass
if [  "$( ps | grep -c "kick" )" -gt 3 ] ; then
	echo "shell script already running "
else

	datetime=`date +%Y-%m-%d_%H:%M:%S`
	if [ ! -f "$logfile" ]; then
		echo "creating kickass logfile: $logfile"
		echo "$datetime: kickass log file created." > $logfile
	fi
	#߳wlan-MACб
	kicklist=""; while true ; do

		datetime=`date +%Y-%m-%d_%H:%M:%S`
		#ļжȡ5GƵεMACַ
		if [ -f "$dev5gmacfile" ] ; then
			dev5gmac=$(cat "$dev5gmacfile")
		fi

		# wlanlist for multiple wlans (e.g., 5GHz/2.4GHz)
		wlanlist="" ; wlanlist=$(ifconfig | grep -i wlan | grep -i -v sta | awk '{ print $1 }')
		#echo "$wlanlist"

		#ȡSSIDΪ2.4GǿźжǷ߳5G豸
		ssid2g5g="" ;	for wlan in $wlanlist ; do 
			ssid2g5g="$ssid2g5g $(iw $wlan info | grep ssid | awk '{ print $2 }')"
		done
		#echo "$ssid2g5g"
		#loop for each wlan
		wlan="" ; for wlan in $wlanlist ; do

			maclist="" ; maclist=$(iw $wlan station dump | awk '/Station/{print $2}')

			#5GƵεAP
			if [ "$(iw $wlan info | grep center1 | awk '{ print $2 }')" -gt "14"  ];then
				#loop for each associated client (station)
				for mac in $maclist ; do
					#5GƵε豸MAC
					if [ -z "$(echo $dev5gmac | grep -i "$mac")"  ] ; then
		    				echo "$mac" >> $dev5gmacfile
						echo  "$datetime: Add new 5G wifi $mac success! " >> $logfile
					fi
					#ȡźǿ
					#signal=$(iwinfo $wlan assoclist  | awk 'BEGIN{IGNORECASE=1}/'$mac'/{print $2}')
					signal=$(iw $wlan station get $mac | awk 'BEGIN{IGNORECASE=1}/'signal.*avg:'/{print $3}')
					#߳ź豸ն˳2.4GƵ
					if [ "$signal"  -le "$WEAK" ] ; then
						#ƥ2߳豸¼߳豸
						if [ -n "$(echo $kicklist | grep -i "$wlan-$mac.*$wlan-$mac")" ] ; then
							ubus call hostapd.$wlan del_client '{"addr":"'"$mac"'", "reason": 5, "deauth": True, "ban_time": 100}' 
							echo  "$datetime: Kick $wlan MAC:$mac signal:$signal dBm switch 2.4G!" >> $logfile
							#߳豸¼ɾ
							kicklist=$(echo $kicklist |sed "s/$wlan-$mac//g")
						else
							#߳豸¼  	
							kicklist="$kicklist$wlan-$mac"
						fi
					else
							#߳豸¼ɾ
							kicklist=$(echo $kicklist |sed "s/$wlan-$mac//g")
					fi
				done
			else
				#2.4GƵεAP
				for mac in $maclist ; do
					#signal=$(iwinfo $wlan assoclist  | awk 'BEGIN{IGNORECASE=1}/'$mac'/{print $2}')
					signal=$(iw $wlan station get $mac | awk 'BEGIN{IGNORECASE=1}/'signal.*avg:'/{print $3}')
					#߳ź豸
					if [ "$signal"  -le "$WEAK" ] ; then
						#ƥ2߳豸¼߳豸
						if [ -n "$(echo $kicklist | grep -i "$wlan-$mac.*$wlan-$mac")" ] ; then
							ubus call hostapd.$wlan del_client '{"addr":"'"$mac"'", "reason": 5, "deauth": True, "ban_time": 3000}' 
							echo  "$datetime: Kick $wlan MAC:$mac signal:$signal dBm tool weak!" >> $logfile
							kicklist=$(echo $kicklist |sed "s/$wlan-$mac//g")
						else  	
							kicklist="$kicklist$wlan-$mac"
						fi
					#߳ǿźţն˳5GƵ(ж:źűSTRONGֵնMAC¼5GƵ2ͬSSIDAP)
 					elif [ "$signal" -gt "$STRONG" -a -n "$(echo $dev5gmac | grep -i "$mac")" -a -n "$( echo "$ssid2g5g" | grep -i  "$(iw $wlan info | grep ssid | awk '{ print $2 }').*$(iw $wlan info | grep ssid | awk '{ print $2 }')" )"  ] ; then
						if [ -n "$(echo $kicklist | grep -i "$wlan-$mac.*$wlan-$mac")" ] ; then
							ubus call hostapd.$wlan del_client '{"addr":"'"$mac"'", "reason": 5, "deauth": True, "ban_time": 100}' 
							echo  "$datetime: Kick $wlan MAC:$mac signal:$signal dBm switch 5G!" >> $logfile
							kicklist=$(echo $kicklist |sed "s/$wlan-$mac//g")
						else  	
							kicklist="$kicklist$wlan-$mac"
						fi

					else
						kicklist=$(echo $kicklist |sed "s/$wlan-$mac//g")
					fi
				done
			fi
		done
		#ʱ
		sleep 2s
	done
fi